<?php
/**
 * MageSpecialist
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to info@magespecialist.it so we can send you a copy immediately.
 *
 * @category   MSP
 * @package    MSP_Shield
 * @copyright  Copyright (c) 2017 Skeeller srl (http://www.magespecialist.it)
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace MSP\Shield\Api;

interface FilterInterface
{
    const NEXT_FILTER = 0; // Jump to next filter
    const MUST_SCAN = 1; // Scan this
    const NO_SCAN = 2; // Do not scan this

    /**
     * Return filter status for a field
     * @param string $fieldName
     * @param string $fieldValue
     * @return boolean
     */
    public function runFilter($fieldName, $fieldValue);
}
